    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2009, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * NormalDistributionFunction2D.java
    029     * ---------------------------------
    030     * (C)opyright 2004-2009, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 25-May-2004 : Version 1 (DG);
    038     * 21-Nov-2005 : Added getters for the mean and standard deviation (DG);
    039     * 12-Feb-2009 : Precompute some constants from the function - see bug
    040     *               2572016 (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.function;
    045
    046    /**
    047     * A normal distribution function.  See
    048     * http://en.wikipedia.org/wiki/Normal_distribution.
    049     */
    050    public class NormalDistributionFunction2D implements Function2D {
    051
    052        /** The mean. */
    053        private double mean;
    054
    055        /** The standard deviation. */
    056        private double std;
    057
    058        /** Precomputed factor for the function value. */
    059        private double factor;
    060
    061        /** Precomputed denominator for the function value. */
    062        private double denominator;
    063
    064        /**
    065         * Constructs a new normal distribution function.
    066         *
    067         * @param mean  the mean.
    068         * @param std  the standard deviation (> 0).
    069         */
    070        public NormalDistributionFunction2D(double mean, double std) {
    071            if (std <= 0) {
    072                throw new IllegalArgumentException("Requires 'std' > 0.");
    073            }
    074            this.mean = mean;
    075            this.std = std;
    076            // calculate constant values
    077            this.factor = 1 / (std * Math.sqrt(2.0 * Math.PI));
    078            this.denominator = 2 * std * std;
    079        }
    080
    081        /**
    082         * Returns the mean for the function.
    083         *
    084         * @return The mean.
    085         */
    086        public double getMean() {
    087            return this.mean;
    088        }
    089
    090        /**
    091         * Returns the standard deviation for the function.
    092         *
    093         * @return The standard deviation.
    094         */
    095        public double getStandardDeviation() {
    096            return this.std;
    097        }
    098
    099        /**
    100         * Returns the function value.
    101         *
    102         * @param x  the x-value.
    103         *
    104         * @return The value.
    105         */
    106        public double getValue(double x) {
    107            double z = x - this.mean;
    108            return this.factor * Math.exp(-z * z / this.denominator);
    109        }
    110
    111    }